#include <iostream>
#include<cstdio>
#include<algorithm>
#include <cmath>
#include <cstdlib>
using namespace std;
const int N=1e7+5,M=7e5+5;
int pr[M];//存质数
bool b[N];//是不是质数 
int n;
int n2;
int t1=0,t;
int cnt=0;
int res;
inline void prime()
{
	for(int i=2;i<N;i++)
	{
		if(!b[i])
		{
			pr[++cnt]=i;
		}
		for(int j=1;j<=cnt&&pr[j]*i<N;j++)
		{
			b[pr[j]*i]=1;
			if(i%pr[j]==0)
			{
				break;
			}
		}
	} 
}
//void ce()
//{
//	cout<<cnt;
//	for(int i=1;i<=cnt;i++)
//	{
//		cout<<pr[i]<<" ";
//	}
//}
inline int doit()
{
	res=0;
	n2=n/2;
	for(int i=1;pr[i]<=n2;i++)
	{
		if(!b[n-pr[i]])
		{
			res++;
		}
	}
	return res;
}
int main()
{
	prime();
//	ce();
	scanf("%d",&t);
	while(t--)
	{
		scanf("%d",&n);
		printf("Case %d: %d\n",++t1,doit());
	}
	return 0;
}
